/////////////////////////////////////////////////////////////////
//Feigenbaum-Diagramm mit ungewöhnlichem Iterator (Polynom 4.Grades)
//////////////////////////////////////////////////////////////


//Bildausschnitt zu Beginn:
float rU = 0  ; 
float rO = 1;
float fU = 0; 
float fO = 4;
float lU = -5;
float lO =1.2;
//Zwischenspeicher:
float  rUNeu, rONeu, fUNeu, fONeu;

float lAlt, fAlt, fNeu, d; 
int w = 800; 
int h = 800; 
int NF, LF;
int i; //Iteration Feigenbaum
float flK; // r-Koordinate für beide
float fyK; //y-Koordinaten Feigenbaum
float NullAchseF;
boolean rKoordatenGezeichnet =false;
float r; //Parameter für logistisches Wachstum


///////////////////////////////////////////////////////////////////////////

void settings() {
  size(w, h);
} 
//Initialisierungen  
void setup() { 
  background(255); 
  rU = 0; 
  rO = 0.9;
  fU = -0.2; 
  fO = 4;
  NF= 1000; //Anzahl Iterationen Feigenbaum
  LF =500; //Feigenbaum ab hier gerechnet
  r = 0.01; //Start r
  d = (rO-rU)/2000; //Schrittweite
 
}

void draw() {
//Beschriftung und Hilfslinien werden weggelassen  
 if (r<0.8){
     r = r +d;
     iteriereF(r);
   }   
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(255);
  rKoordatenGezeichnet =false;
  rUNeu = map(mouseX, 0, w, rU, rO)-(rO-rU)/10;
  rONeu = map(mouseX, 0, w, rU, rO)+(rO-rU)/10;
  fUNeu = map(mouseY, 0, h, fO, fU)-(fO-fU)/10;
  fONeu = map(mouseY, 0, h, fO, fU)+(fO-fU)/10;
  rU = rUNeu; 
  rO = rONeu; 
  fU = fUNeu; 
  fO = fONeu;
  r = rU; 
  d = (rO-rU)/1000;
  NF = NF+100;
  LF = LF +200;
  println("mousePressed startet");
    
}
//////////////////////////////////////////////////////////
//Feigenbaum-Iteration
////////////////////////////////////////////////////////
void iteriereF(float r) {  
  stroke(0);
   strokeWeight(1.2);
  fAlt = 0.2;// println(fAlt,r);
  flK = map(r, rU, rO, 0, w);      
  i=0;
  while (i <=NF) {
   
    fNeu =  r*(-1.25*pow(fAlt,4)+10*pow(fAlt,3)-25.75*fAlt*fAlt+23*fAlt);
   // println(fNeu);
    if (i < LF && abs(fNeu) < 20) {
      fyK = map(fNeu, fU, fO, h, 0);   
      point(flK, fyK);    //println(flK,fyK);
    }
    fAlt = fNeu;
    i++;
  }
 
}